import Vapor

func routes(_ app: Application) throws {
    // https://127.0.0.1:8000
    app.get { req async in
        "It works!"
    }

    // https://127.0.0.1:8000/hello
    app.get("hello") { req async -> String in
        "Hello, world!"
    }
     
    app.get("customers", ":customerId") { req async throws -> String in
        
        guard let customerId = req.parameters.get("customerId", as: Int.self) else {
            throw Abort(.badRequest)
        }
        
        return "\(customerId)"
    }
            
    // /movies/action
    // /movies/horror
    // /movies/kids
    // /movies/abc
    // route parameters/dynamic parameters
    app.get("movies", ":genre") { req async throws -> String in
        
        guard let genre = req.parameters.get("genre") else {
            throw Abort(.badRequest)
        }
        return "Alll movies of genre: \(genre)"
    }
    
    // /movies/action/2023
    app.get("movies", ":genre", ":year") { req async throws -> String in
        
        guard let genre = req.parameters.get("genre"),
              let year = req.parameters.get("year")
        else {
            throw Abort(.badRequest)
        }
        
        return "Alll movies of genre: \(genre) for year \(year)"
        
    }
}
